library omnibus.test.omnibus_test;

import 'dart:async';
import 'dart:collection';

import 'package:omnibus/omnibus.dart';
import 'package:test/test.dart';

class TextEvent extends OmnibusEvent
{
    static final String type = 'test.TextEvent';
    String get instanceType => type;

    TextEvent(String text) : super(text);
}

class TextReply extends OmnibusReply
{
    static final String type = 'test.TextReply';
    String get instanceType => type;

    TextReply(String text) : super(text);
}

class TextListener extends OmnibusListener
{
    bool probe(OmnibusEvent event)
    {
        return event.data.endsWith('!');
    }

    Future<OmnibusReply> receive(OmnibusEvent event) async
    {
        Completer completer = new Completer<OmnibusReply>();

        Timer timer = new Timer(
            new Duration(milliseconds: 100),
            () => completer.complete(new OmnibusReply(
                event.data.substring(0, event.data.length - 1))));

        return completer.future;
    }
}

main()
{
    test('Omnibus await replies', () async
        {
            Omnibus bus = new Omnibus();

            bus.subscribe(TextEvent.type, new TextListener());

            Set<OmnibusReply> replies = await bus.emit(
                new TextEvent('Hello World!'));

            expect(replies.single.data, equals("Hello World"));
        });
}
